#include <iostream>
#include <string>

using namespace std;

string Sum(string A, string B)
{
    A = "0" + A;
    B = "0" + B;

    while (A.length() != B.length())
    {
        if (B.length() < A.length())
        {
            B = "0" + B;
        }
        else
        {
            A = "0" + A;
        }
    }

    string Result = A;
    long Carry = 0;

    for (long i = A.length() - 1; i >= 0; i--)
    {
        Result[i] = (A[i] - '0' + B[i] - '0' + Carry) % 10 + '0';
        Carry = (A[i] - '0' + B[i] - '0' + Carry) >= 10;
    }

    while (Result[0] == '0' && Result.length() > 1)
    {
        Result = Result.substr(1, Result.length() - 1);
    }

    return Result;
}

string Diff(string A, string B)
{
    A = "0" + A;
    B = "0" + B;

    while (A.length() != B.length())
    {
        if (B.length() < A.length())
        {
            B = "0" + B;
        }
        else
        {
            A = "0" + A;
        }
    }

    string Result = A;
    long Carry = 0;

    for (long i = A.length() - 1; i >= 0; i--)
    {
        Result[i] = ((A[i] - '0') - (B[i] - '0') - Carry + 10) % 10 + '0';
        Carry = ((A[i] - '0') - (B[i] - '0') - Carry) < 0;
    }

    while (Result[0] == '0' && Result.length() > 1)
    {
        Result = Result.substr(1, Result.length() - 1);
    }

    return Result;
}

string Power2(long Exp)
{
    string Current = "1";

    for (long i = 0; i < Exp; i++)
    {
        Current = Sum(Current, Current);
    }
    return Current;
}

int main()
{
    string N;
    long IN;
    string M;

    cin >> IN;
    cin >> M;

    N = Power2(IN);

    if (M[0] == '-')
    {
        cout << Sum(N, M.substr(1, M.length() - 1));
        return 0;
    }

    cout << Diff(N, M);
}
